//===----------------------------------------------------------------------===//
//
// Philipp Schubert
//
//    Copyright (c) 2017 - 2021
//    Secure Software Engineering Group
//    Heinz Nixdorf Institute
//    Paderborn University
//    philipp.schubert@upb.de
//
//===----------------------------------------------------------------------===//

#include <iostream>

template <class T> class base {
protected:
  T base_value;

public:
  base(T t) : base_value(t) {}
};

template <class T> class derived : public base<T> {
private:
  T derived_value;

public:
  derived(T t, T u) : base<T>(u), derived_value(t) {}
  void printValues() {
    std::cout << base_value << '\n';
    std::cout << derived_value << '\n';
  }
};

int main() {
  derived<int> d(20, 10);
  d.printValues();
  return 0;
}
